unit pasCommon;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,

  // R|[lg̒`ɕKvȃjbg
  Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Samples.Spin,

  // ȉ͊֐ɂĂ͒ǉKv
  Winapi.WinSock,     // IPAhX擾Ɏgp
  System.IniFiles,    // INIt@CǂݏɎgp
  System.AnsiStrings, // oCgPʂ̕񑀍Ɏgp
  System.Math,        // SimpleRoundTo̐wɎgp
  System.Types,       // t@Cꗗ擾TStringDynArray`Ɏgp
  System.IOUtils;     // TDirectoryt@C֘AɎgp

type
  // o[W̎擾Ŏgp^
  TVerResourceKey = (
        vrComments,         // Rg
        vrCompanyName,      // Ж
        vrFileDescription,  // 
        vrFileVersion,      // t@Co[W
        vrInternalName,     // 
        vrLegalCopyright,   // 쌠
        vrLegalTrademarks,  // W
        vrOriginalFilename, // t@C
        vrPrivateBuild,     // vCx[grh
        vrProductName,      // i
        vrProductVersion,   // io[W
        vrSpecialBuild);    // XyVrh

  // tH_T̃IvVŎgp^
  TListDirOption = (ldNone, ldSubSearch, ldOmitFolder, ldBoth);

// ֐錾
function APPFolder: String;                                                     // EXE̊KwԂ
function GetCompName: String;                                                   // Rs[^擾
function GetWinUser: String;                                                    // [U[擾
function GetVersionInfo(FileName:string; KeyWord: TVerResourceKey): string;     // o[W̎擾
function GetIPAddress: AnsiString;                                              // IPAhX擾
procedure WriteLog(AMsg: String);                                               // Oo(ȈՔ)
function GetIniFile(sFileName, sSection, sKey :String; sDefault :String = ''): String; // init@C擾
procedure SetIniFile(sFileName, sSection, sKey, sValue: String);                // init@C
function GetCharLength(AText: AnsiString): Integer;                             // 擾
function GetLengthText(AText: AnsiString; AMaxLength: Integer): AnsiString;     // w蒷擾
function FillBlank(S: String; iLength: Integer; bLeft: Boolean = False): String;// puNߏ
function FillZero(S: String; iLength: Integer; bLeft: Boolean = True): String;  // p[ߏ
function SinglebyteToDoublebyte(sValue: string): string;                        // pSpɕϊ
function DoublebyteToSinglebyte(sValue: string): string;                        // Spp𔼊pɕϊ
function ShrinkSpaces(AString: String): String;                                 // SpXy[X͔pXy[XƂA͋l߂
function AddSISO(AStr: AnsiString): String;                                     // SI/SÖʒuɃ_~[̔pXy[XZbg
function RmvSISO(AStr: WideString): String;                                     // SI/SÖʒu̔pXy[XJbg
function DateToInt(ADate: TDate): Integer;                                      // tl擾
function IntToDate(ADateInteger: Integer): TDate;                               // ^Delphit^ւ̕ϊ
function TimeToInt(ATime: TTime): Integer;                                      // l擾
function IntToTime(ATimeInteger: Integer): TTime;                               // ^Delphi^ւ̕ϊ
function GetBeforeHalfYear(ADateInteger: Integer): Integer;                     // NO̓t擾
function GetGetsumatsu(ADateInteger: Integer): Integer;                         // ̓tl擾
function Division(A, B: Double; iRound: Integer = 2000): Double;                // Z(vZtA0Z̃G[h~)
function GetNowComp: TComponent;                                                // ݃}EXĂꏊ̐^ɂR|[lg擾
procedure Saizenmen(ATopMost: Boolean; AHWND: HWND);                            // ΏۃEChE̍őOʕ\/
function ListDirTree(APath: string; var AList: TStringList; Aldo: TListDirOption= ldNone): Boolean; // w肵fBNg̃t@Cꗗ쐬
procedure NeccesaryCheck(AEdt: TWinControl; AErr, AMoth: string);               // EditK{`FbN
function GPStoDistance(AK1, AI1, AK2, AI2: Double): Double;                     // 2_Ԃ̌oxƈܓx璼v


implementation

{*******************************************************************************
 ړI: EXE̊KwԂ
 :
 ߒl: EXE̊KwiɁuvtj
*******************************************************************************}
function AppFolder: string;
begin
  Result := ExtractFilePath(Application.Exename);
end;

{*******************************************************************************
 ړI: Rs[^擾
 :
 ߒl: 擾Rs[^
*******************************************************************************}
function GetCompName: String;
var
  sBuffer: array [0..MAX_COMPUTERNAME_LENGTH] of AnsiChar;
  nSize: DWord;
begin
  nSize := SizeOf(sBuffer);

  if GetComputerNameA(sBuffer, nSize) then
    Result := Trim(sBuffer)
  else
    Result := '';
end;

{*******************************************************************************
 ړI: [U[擾
 :
 ߒl: 擾[U[
*******************************************************************************}
function GetWinUser: String;
var
  sBuffer: array [0..20] of AnsiChar;
  nSize: DWord;
begin
  nSize := SizeOf(sBuffer);

  if GetUserNameA(sBuffer, nSize) then
    Result := Trim(sBuffer)
  else
    Result := '';
end;

{*******************************************************************************
 ړI: o[W̎擾
 : FileName - 擾t@C̃tpX
       KeyWord  - 擾o[WiTVerResourceKey̒1Iԁj
 ߒl: 擾o[W
*******************************************************************************}
const
  KeyWordStr: array [TVerResourceKey] of String = (
        'Comments',        // Rg
        'CompanyName',     // Ж
        'FileDescription', // 
        'FileVersion',     // t@Co[W
        'InternalName',    // 
        'LegalCopyright',  // 쌠
        'LegalTrademarks', // W
        'OriginalFilename',// t@C
        'PrivateBuild',    // vCx[grh
        'ProductName',     // i
        'ProductVersion',  // io[W
        'SpecialBuild');   // XyVrh

function GetVersionInfo(FileName:string; KeyWord: TVerResourceKey): string;
const
  Translation = '\VarFileInfo\Translation';
  FileInfo = '\StringFileInfo\%0.4s%0.4s\';
var
  BufSize, HWnd: DWORD;
  VerInfoBuf: Pointer;
  VerData: Pointer;
  VerDataLen: Longword;
  PathLocale: String;
begin

  BufSize := GetFileVersionInfoSize(PChar(FileName), HWnd);
  if BufSize <> 0 then
  begin
    GetMem(VerInfoBuf, BufSize);
    try
      GetFileVersionInfo(PChar(FileName), 0, BufSize, VerInfoBuf);
      VerQueryValue(VerInfoBuf, PChar(Translation), VerData, VerDataLen);
      if not (VerDataLen > 0) then
        raise Exception.Create('̎擾Ɏs܂');
      PathLocale := Format(FileInfo + KeyWordStr[KeyWord],
        [IntToHex(Integer(VerData^) and $FFFF, 4),
         IntToHex((Integer(VerData^) shr 16) and $FFFF, 4)]);
      VerQueryValue(VerInfoBuf, PChar(PathLocale), VerData, VerDataLen);
      if VerDataLen > 0 then
      begin
        result := '';
        SetLength(result, VerDataLen);
        StrLCopy(PChar(result), VerData, VerDataLen);
      end;
    finally
      FreeMem(VerInfoBuf);
    end;
  end;
end;


//yXEȑÕo[Wł͂gpzi錾TVerResourceKeysvj
//function GetProductVersion(PGNM: String): AnsiString;
//var
//  Size, SizeFileInfo, Ret: DWORD; pData, pInfo: Pointer;
//begin
//  try
//    Size := GetFileVersionInfoSize(PChar(PGNM), Ret);
//    GetMem(pData, Size);
//    try
//      Assert(GetFileVersionInfo(PChar(PGNM), 0, Size, pData));
//      Assert(VerQueryValue(pData,
//        PChar('\StringFileInfo\041103A4\FileVersion'), pInfo,
//        SizeFileInfo));
//      Result := PChar(pInfo);
//    finally
//      FreeMem(pData);
//    end;
//  except
//    Result := 'N/A';  //----- f[^擾łȂꍇ
//  end;
//end;

{*******************************************************************************
 ړIFIPAhX擾
 F
 ߒlF擾IPAhX
*******************************************************************************}
function GetIPAddress: AnsiString;
var
  wsaData  : TWsaData;
  hostName : array [0..255] of AnsiChar;
  host    : PHostEnt;
  in_addr  : TInAddr;
begin
  // IPAhX擾
  WSAStartup($101, wsaData);
  try
    gethostname(hostName,sizeof(hostName));
    host    := gethostbyname(hostName);
    in_addr  :=PInAddr(PInAddr(host^.h_addr_list)^)^;
    Result := inet_ntoa(in_addr);
  finally
    WSACleanup;
  end;
end;

{*****************************************************************************
 ړI: Oo(ȈՔ) ̂܂ܑΏۃ\[X̊֐葱ɂł܂
*****************************************************************************}
procedure WriteLog(AMsg: String);
var
  FLog: TextFile;
  SLog: string;
  sLogFileName: String;
begin
  // Ot@C̎擾iłEXEƓlogt@Cój
  sLogFileName := ChangeFileExt(Application.ExeName, '.log');

  // Oo
  try
    // t@Cϐ֘At
    AssignFile(FLog, sLogFileName);
    try
      if FileExists(sLogFileName) then
        Append(FLog)     // t@C̖ɒǉ
      else
        Rewrite(FLog);   // Vt@C쐬J

      // o̓bZ[W쐬
      SLog := FormatDateTime('YYYY/MM/DD HH:NN:SS', Now) + '  ' + AMsg;
      // t@C֏o
      Writeln(FLog, SLog);
    finally
      // t@C֘AtI
      CloseFile(FLog);
    end;
  except
    // OoɎsꍇȂ
  end;
end;

{*******************************************************************************
 ړI: init@C擾
 : sFileName - t@C(tpX)
       sSection  - ZNV
       sKey      - L[
       sDefault  - 擾s̃ftHgl
 ߒl: 擾
*******************************************************************************}
function GetIniFile(sFileName, sSection, sKey :String; sDefault :String = ''): String;
const
  cINIReadError  = 'INIt@C񂪎擾ł܂B' + #13#10 + 'Section = %s , Key = %s';
var
  FileIni: TIniFile;
begin
  // init@C̓ǂݍ
  FileIni := TIniFile.Create(sFileName);
  try
    try
      Result := FileIni.ReadString(sSection, sKey , sDefault);
    except
      raise Exception.Create(Format(cINIReadError, [sSection, sKey]));
    end;
  finally
    FileIni.Free;
  end;
end;

{*******************************************************************************
 ړI: init@C
 : sFileName - t@C(tpX)
       sSection  - ZNV
       sKey      - L[
       sValue    - l
 ߒl:
*******************************************************************************}
procedure SetIniFile(sFileName, sSection, sKey, sValue: String);
const
  cINIWriteError = 'INIt@C񂪐ݒł܂B' + #13#10 + 'Section = %s , Key = %s';
var
  FileIni: TIniFile;
begin
  // INIt@C̏ݍ
  FileIni := TIniFile.Create(sFileName);
  try
    try
      if sKey <> '' then
        FileIni.WriteString(sSection, sKey, sValue)
      else
        FileIni.EraseSection(sSection);
    except
      raise Exception.Create(Format(cINIWriteError, [sSection, sKey]));
    end;
  finally
    FileIni.Free;
  end;
end;

{*******************************************************************************
 ړI: 擾
 : AText - Y
 ߒl: Vtg܂ޕ
*******************************************************************************}
function GetCharLength(AText: AnsiString): Integer;
var
  i: integer;
  InDBCS: Boolean;
begin
  InDBCS := False;
  Result := Length(AText);
  // 擾
  for i := 1 to Length(AText) do
  begin
    case System.AnsiStrings.ByteType(AText, i) of
      mbSingleByte: // ASCII ͔pJ^Ji
        InDBCS := False;
      mbLeadByte:   // 2oCg1oCg
        if InDBCS = False then
        begin
          InDBCS := True;
          Result := Result + 2;
        end;
      mbTrailByte:  // 2oCg2oCg
        ;
    end;
  end;
end;

{*******************************************************************************
 ړI: w蒷擾
 : AText - Ώە
       AMaxLength - 擾oCg(Vtg)
 ߒl: oCgɎ܂镶
*******************************************************************************}
function GetLengthText(AText: AnsiString; AMaxLength: Integer): AnsiString;
begin
  if (AMaxLength <= 0) or (GetCharLength(AText) <= AMaxLength) then
    Result := AText
  else
  begin
    repeat
      AText := Copy(WideString(AText), 1, Length(WideString(AText)) - 1);
    until (GetCharLength(AText) <= AMaxLength);
    Result := AText;
  end;
end;

{*******************************************************************************
 ړIFpuNߏiw肳ꂽoCgɂȂ悤ɔpXy[Xt^j
 FS - Ώە
       iLength - oCgw
       bLeft   - TrueɃuN FalseEɃuN(l)
 ߒlFuN߂ꂽ
*******************************************************************************}
function FillBlank(S: String; iLength: Integer; bLeft: Boolean = False): String;
var
  i: Integer;
begin
  i := Length(AnsiString(S));
  if iLength > i then
  begin
    if bLeft then
    begin // bLeftTrue͍̎ɃXy[Xl߂
      Result := StringOfChar(' ', iLength - i) + S;
    end
    else
    begin // bLeftFalse͉̎EɃXy[Xl߂
      Result := S + StringOfChar(' ', iLength - i);
    end;
  end
  else
  begin
    Result := S;
  end;
end;

{*******************************************************************************
 ړIFp[ߏiw肳ꂽoCgɂȂ悤Ɂu0vt^j
 FS - Ώە
       iLength - oCgw
       bLeft   - TrueɃ[(l) FalseEɃ[
 ߒlF0߂ꂽ
*******************************************************************************}
function FillZero(S: String; iLength: Integer; bLeft: Boolean = True): String;
var
  i: Integer;
begin
  i := Length(AnsiString(S));
  if iLength > i then
  begin
    if bLeft then
    begin // bLeftTrue͍̎Ɂu0vl߂
      Result := StringOfChar('0', iLength - i) + S;
    end
    else
    begin // bLeftFalse͉̎EɁu0vl߂
      Result := S + StringOfChar('0', iLength - i);
    end;
  end
  else
  begin
    Result := S;
  end;
end;

{*******************************************************************************
 ړIFpSpɕϊ
 FsValue - Ώە
 ߒlFpSpɂȂ
*******************************************************************************}
function SinglebyteToDoublebyte(sValue: string): string;
var
  cChr : array[0..255] of char;
begin
  if 0 = Length(sValue) then
    Result := ''
  else
  begin
    Fillchar(cChr, Length(sValue)*2+2, 0);
    LCMapString(LOCALE_SYSTEM_DEFAULT, LCMAP_FULLWIDTH, Pchar(sValue), Length(sValue),
                cChr, Length(sValue)*2+1);
    Result := string(cChr);
  end;
end;

{*******************************************************************************
 ړIFSp𔼊pɕϊ
       yёSpL̑啔(X֔ԍ)͍폜܂B
       Unicodeˑ͔Ή
 FsValue - Ώە
 ߒlFʂ̕
*******************************************************************************}
function DoublebyteToSinglebyte(sValue: string): string;
var
  cBuff: PAnsiChar;
  iSize: Integer;
  sDelete: AnsiString;
begin
  Result := '';

  // ϊ̕TCY擾(ϊ̃TCY0ȂI)
  iSize := LCMapStringA(LOCALE_SYSTEM_DEFAULT,
                        LCMAP_KATAKANA or LCMAP_HALFWIDTH,
                        PAnsiChar(AnsiString(sValue)), Length(AnsiString(sValue)), nil, 0);
  if iSize = 0 then
    exit;

  // ϊ̕obt@m
  cBuff := AllocMem(iSize + 1);
  try
    // ϊAobt@Ɏ󂯎
    iSize := LCMapStringA(LOCALE_SYSTEM_DEFAULT,
                          LCMAP_KATAKANA or LCMAP_HALFWIDTH,
                          PAnsiChar(AnsiString(sValue)), Length(AnsiString(sValue)), cBuff, iSize);
    // ϊ̕TCYmFA֐̖߂lɃZbg
    if iSize <> 0 then
      Result := System.AnsiStrings.StrPas(cBuff);
  finally
    // obt@Ɋmۂ
    FreeMem(cBuff);
  end;

  for iSize := Length(AnsiString(Result)) downto 1 do
  begin
    if System.AnsiStrings.ByteType(AnsiString(Result), iSize) = mbLeadByte then
    begin
      sDelete := AnsiString(Result);
      Delete(sDelete, iSize, 2);
      Result := sDelete;
    end;
  end;
end;

{*******************************************************************************
 ړI: SpXy[X͔pXy[XƂAAXy[X͋l߂ĂPɂ
 : AString - ̕
 ߒl: ̕
*******************************************************************************}
function ShrinkSpaces(AString: String): String;
var
  ii: Integer;
begin

  // SpXy[X𔼊pɂ
  Result := StringReplace(AString, '@', ' ', [rfReplaceAll, rfIgnoreCase]);
  ii     := Pos('  ', Result);

  // AXy[Xl߂1ɂ
  while (ii >= 1) do
  begin
    Result := StringReplace(Result, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
    ii     := Pos('  ', Result);
  end;
end;

{*******************************************************************************
 ړI: ɑ΂āASI/SÖʒuɃ_~[̔pXy[XZbg
 : ̕
 ߒl: `ꂽ
*******************************************************************************}
function AddSISO(AStr: AnsiString): String;
var
  i: Integer;
  S: AnsiString;
begin
  // (l) 1oCgڂSp̏ꍇ
  if (System.AnsiStrings.ByteType(AStr, 1) = mbLeadByte) then
  begin
    S := ' ';
  end
  // (l) 1oCgڂp̏ꍇ
  else
  begin
    S := '';
  end;

  // mFASpƔp̐ؑփ|CgɃ_~[̔pXy[XZbg
  for i := 1 to Length(AStr) do
  begin
    S := S + AStr[i];

    if (System.AnsiStrings.ByteType(AStr, i) = mbSingleByte) then
    begin
      if (System.AnsiStrings.ByteType(AStr, i + 1) = mbLeadByte) then
      begin
        S := S + ' ';
      end;
    end;

    if (System.AnsiStrings.ByteType(AStr, i) = mbTrailByte) then
    begin
      if (System.AnsiStrings.ByteType(AStr, i + 1) = mbSingleByte) then
      begin
        S := S + ' ';
      end;
    end;
  end;

  Result := String(S);
end;

{*******************************************************************************
 ړI: ɑ΂āASI/SÖʒu̔pXy[XJbg
 : ̕(SI/SOlς݂̕񂪓ĂO)
 ߒl: `ꂽ
*******************************************************************************}
function RmvSISO(AStr: WideString): String;
var
  i: Integer;
  bSO: Boolean;
begin

  Result := '';
  bSO    := False;

  if AStr <> '' then
  begin
    // PʂŌ납JEg
    for i := Length(AStr) downto 2 do
    begin
      // 1̕ŃtOZbgꂽpXy[X(SO)̂ƂAZbgȂ
      if (bSO) then
      begin
        bSO := False;
      end
      else
      // pXy[X(SI)1O̕Sp̂ƂAZbgȂ
      if (AStr[i] = ' ') and (Length(AnsiString(AStr[i - 1])) = 2) then
      begin
      end
      else
      begin
        // Zbg
        Result := AStr[i] + Result;

        // Sp1O̕pXy[X(SO)̂ƂAtOZbg
        if (Length(AnsiString(AStr[i])) = 2) and (AStr[i - 1] = ' ') then
        begin
          bSO := True;
        end;
      end;
    end;

    // Spn܂łȂꍇ1(SIłȂ)Ōɑ
    if (not bSO) then
    begin
      Result := AStr[1] + Result;
    end;

  end;
end;

{*******************************************************************************
 ړI: tl擾
 : ADate - tl
 ߒl: ʐl
*******************************************************************************}
function DateToInt(ADate: TDate): Integer;
begin
  Result := 0; // (ɈvȂꍇ0Ԃ)

  if not VarIsNull(ADate) then
  begin
    if (ADate <> 0) then
    begin
      try
        Result := StrToInt(FormatDateTime('yyyymmdd', ADate));
      except
        raise; // WbNł́utl܂Bvo
      end;
    end;
  end;
end;

{*******************************************************************************
 ړI: ^Delphit^ւ̕ϊ
 : ^
 ߒl: Delphit
*******************************************************************************}
function IntToDate(ADateInteger: Integer): TDate;
var
  iYear, iMonth, iDay: Integer;
begin
  Result := 0;
  if ADateInteger <> 0 then
  begin
    iYear  := StrToInt(Copy(FormatFloat('00000000', ADateInteger), 1, 4));
    if iYear < 100 then
    begin
      if iYear < 50 then
        iYear := 2000 + iYear
      else
        iYear := 1900 + iYear;
    end;
    iMonth := StrToInt(Copy(FormatFloat('00000000', ADateInteger), 5, 2));
    iDay   := StrToInt(Copy(FormatFloat('00000000', ADateInteger), 7, 2));
    Result := EncodeDate(iYear, iMonth, iDay);
  end;
end;

{*******************************************************************************
 ړI: l擾
 : ATime - l
 ߒl: ʐlihhnnssj
*******************************************************************************}
function TimeToInt(ATime: TTime): Integer;
begin
  Result := 0; // (ɈvȂꍇ0Ԃ)

  if not VarIsNull(ATime) then
  begin
    if (ATime <> 0) then
    begin
      try
        Result := StrToInt(FormatDateTime('hhnnss', ATime));
      except
        raise; // WbNł́ul܂Bvo
      end;
    end;
  end;
end;

{*******************************************************************************
 ړI: ^Delphit^()ւ̕ϊ
 : ^ihhnnssj
 ߒl: Delphi
*******************************************************************************}
function IntToTime(ATimeInteger: Integer): TTime;
var
  sTime: string;
begin
  Result := 0;
  if(ATimeInteger > 0) then
  begin
    sTime   := FormatFloat('000000', ATimeInteger);
    Result  := EncodeTime(StrToIntDef(Copy(sTime, 1, 2), 0),
                          StrToIntDef(Copy(sTime, 3, 2), 0),
                          StrToIntDef(Copy(sTime, 5, 2), 0),
                          0);
  end;
end;

{*******************************************************************************
 ړI: NO̓t擾
 : ^(YYYYMMDD)
 ߒl: ʐl(YYYYMMDD)
*******************************************************************************}
function GetBeforeHalfYear(ADateInteger: Integer): Integer;
var
  dDate: TDate;
begin
  // t^ɕϊ
  dDate  := IntToDate(ADateInteger);

  // 6Oɖ߂
  dDate  := IncMonth(dDate, -6); // 6O

  // l^ɕϊ
  Result := DateToInt(dDate);
end;

{*******************************************************************************
 ړI: ̓tl擾
 : ^(YYYYMMDD)
 ߒl: ̓tl(YYYYMMDD)
*******************************************************************************}
function GetGetsumatsu(ADateInteger: Integer): Integer;
var
  dTemp: TDate;
begin
  Result := ADateInteger;

  // tlǂ(tłȂꍇExit)
  try
    IntToDate(ADateInteger);
  except
    Exit;
  end;

  // ̓t擾
  dTemp  := IntToDate(Trunc(SimpleRoundTo((ADateInteger * 1.00), 2) + 1)); // 1t^ɂ
  dTemp  := IncMonth(dTemp, 1);   // 1ɂ
  Result := DateToInt(dTemp - 1); // 1̑OԂ
end;

{*******************************************************************************
 ړI: Z(vZtA0Z̃G[h~)
 : 鐔Ɗ鐔(AB)Aľܓ(͂̏ꍇ͎ľܓȂ)
 ߒl: vZ
*******************************************************************************}
function Division(A, B: Double; iRound: Integer = 2000): Double;
begin
  if B = 0 then
    Result := 0 // 鐔0̏ꍇAʂ0ƂăG[
  else
  begin
    Result := A / B;

    // Ŏľܓݒ肳ĂꍇAw肳ꂽ܂Ŏľܓs
    if (iRound <> 2000) then
    begin
      Result := SimpleRoundTo(Result, iRound);
    end;
  end;
end;

{*******************************************************************************
 ړI: ݃}EXĂꏊ̐^ɂR|[lg擾
 :
 ߒl: ΏۃR|[lgiꍇnilԂj
*******************************************************************************}
function GetNowComp: TComponent;
var
  P : TPoint;
begin
  // ɍŐV̏Ԃ擾邽߁ATimerAction.UpdateœsxĂяo

  // }EXʒu̎擾
  GetCursorPos(P);
  // ݃}EXĂꏊ̐^ɂR|[lg擾
  Result := FindDragTarget(P, True);
end;

{*******************************************************************************
 ړI: ΏۃEChE̍őOʕ\/
 : ATopMost - TrueőOʕ\AFalseőOʉ
       AHWND    - ΏۃEChEnh
 ߒl: ΏۃR|[lg̖O
*******************************************************************************}
procedure Saizenmen(ATopMost: Boolean; AHWND: HWND);
begin
  if (ATopMost) then
  begin
    // őOʂɕ\
    SetWindowPos(AHWND,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);
  end
  else
  begin
    // ʂɖ߂
    SetWindowPos(AHWND,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);
  end;
end;

{*******************************************************************************
 ړI: w肵fBNg̃t@Cꗗ쐬
 : APath - ΏۃfBNg̃pX
       AList - (߂l)ʑpStringList
       Aldo  - IvV(ldNoneȂ ldSubSearchTutH_Q
                          ldOmitFolderTutH_̂̂͏O ldBoth)
 ߒl: 
*******************************************************************************}
function ListDirTree(APath: string; var AList: TStringList; Aldo: TListDirOption = ldNone): Boolean;
var
  LDirList : TStringDynArray;
  LFilesList : TStringDynArray;
  LDirName : String;
  LFileName  : String;
begin

  // AListɂ͒ǋL邽߁AKvȏꍇ͌ďołĂ

  Result := False; // 

  // AList݂Ȃꍇ
  if (not Assigned(AList)) then
  begin
    AList := TStringList.Create;
  end;

  // APath݂ȂꍇI
  if (not DirectoryExists(APath)) then
  begin
    Exit;
  end;

  // APath̃fBNg̃Xg쐬
  LDirList := TDirectory.GetDirectories(APath);
  for LDirName in LDirList do
  begin
    // (w莞̂)TutH_ʂɒǉ
    if (Aldo in [ldNone, ldSubSearch]) then
    begin
      AList.Add((LDirName));
    end;

    // (w莞̂)TutH_ċA
    if (Aldo in [ldSubSearch, ldBoth]) then
    begin
      ListDirTree(LDirName, AList, Aldo);
    end;
  end;

  // APath̃t@C̃Xg쐬
  LFilesList := TDirectory.GetFiles(APath);
  for LFileName in LFilesList do
  begin
    AList.Add((LFileName));
  end;

  AList.Sort; // OɃ\[g
  Result := True;
end;

{*******************************************************************************
 ړI: EditK{`FbN
 : AEdt   - `FbNΏEdit
       AErr   - G[constl
       AMoth  - Hl(1ނ̂)
 ߒl:
*******************************************************************************}
procedure NeccesaryCheck(AEdt: TWinControl; AErr, AMoth: string);
begin

  if ((AEdt is TEdit) and     (Trim((AEdt as TEdit).Text) = '')) or        // TEditŃuN
     ((AEdt is TMemo) and     (Trim((AEdt as TMemo).Lines.Text) = '')) or  // ŃuN
     ((AEdt is TSpinEdit) and ((AEdt as TSpinEdit).Value = 0)) then        // l͍ڂœ͒l0
  begin
    // G[bZ[WԂătH[JXZbgAf
    ShowMessage(AMoth + AErr);
    if (AEdt.CanFocus) then
    begin
      AEdt.SetFocus;
    end;
    Abort;
  end;
end;

{*******************************************************************************
 ړI: 2_Ԃ̌oxƈܓx璼v o/oAk/܂ׂ͌ȂO
 : AK1 - n_P̌ox
       AI1 - n_P̈ܓx
       AK2 - n_Q̌ox
       AI2 - n_Q̈ܓx
 ߒl: v([g)
*******************************************************************************}
function GPStoDistance(AK1, AI1, AK2, AI2: Double): Double;
const
  cIDO111  = 111.3194908;  // ܓx1xkm
var
  distK, distI: Double;
begin

  // k̋ix̍~ܓx1xkmj
  distI := Abs((AI1 - AI2)) * cIDO111;

  // ̋ix̍~ܓxɂcosl~ܓx1xkmj
  distK := Abs((AK1 - AK2)) * Cos((AI1 + AI2) / 2 * Pi / 180) * cIDO111;

  // O̒藝ŋvZ
  Result := Sqrt(Sqr(distI) + Sqr(distK));
  Result := Result * 1000;  // kmmɕϊ
end;



end.

